var slideshow, slideSelect;

var shares=null;
// H5 plus事件处理
function plusReady(){
	plus.navigator.setFullscreen(true);
	updateSerivces();
}
if(window.plus){
	plusReady();
}else{
	document.addEventListener('plusready', plusReady, false);
}
/**
 * 更新分享服务
 */
function updateSerivces(){
	plus.share.getServices(function(s){
		shares={};
		for(var i in s){
			var t=s[i];
			shares[t.id]=t;
		}
	}, function(e){
	});
}


var getParam = function getQueryString(name) {
    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
    var r = window.location.search.substr(1).match(reg);
    if (r != null) return unescape(r[2]); return null;
    }


var guid = function(){
  	return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
    var r = Math.random()*16|0, v = c == 'x' ? r : (r&0x3|0x8);
   	return v.toString(16);
  });
}

var getDeviceId = function()
{
	deviceId = window.localStorage.getItem("trust_device_id");
	if(typeof deviceId == 'undefined' || deviceId == null){
		deviceId = guid();
		deviceId = window.localStorage.setItem("trust_device_id", deviceId);
	}
	return window.localStorage.getItem("trust_device_id");
}

// banner信息
var requestBanner = function(){
	var channelId = getParam('td_channelid');
	if(!channelId)
	{
		channelId = "";
	}
	var plat = CHANNEL[channelId.toLowerCase()]; // 默认安卓1。历史原因跟别的游戏不一样。
	// if(browserzj.versions.iPhone || browserzj.versions.iPad || browserzj.versions.ios)
	// {
	// 	plat = 0;
	// }
	if(typeof plat == "undefined")
	{
		plat = 1;
	}
	var deviceId = getDeviceId();
	var request = pegasus("http://{0}/GameConfig.php?data={%22game_id%22:{1},%22plat%22:{2}}&device_id={3}&channel_name={4}".formatzj(BANNER_IP, GAME_ID, plat,deviceId,channelId));
	request.then(
		
		// success handler
		function(data, xhr) {
			// Convert HTML...
			var res = JSON.parse(xhr.response);
			if(res.code == 0)
			{ 
				// banner
				var ran = randomzj(0, res.data.banner.length - 1);
				var ranData = res.data.banner[ran];
				for (var i = res.data.banner.length - 1; i >= 0; i--) {
					$("#bannerImg").src = ranData.banner_url;
					// $("#bannerLink").href = ranData.jump_url;
					// todo 区分pc和移动端
					$("#bannerLink").onclick = function(){
						plus.runtime.openURL(ranData.jump_url);
					};
					$("#bannerFooter").style.display = "block";
					break;
				}

				// game
				var game = res.data.game;
				SHARE_LINK = game.share_url;
				SHARE_TITLE_CHAT = game.share_title_chat;
				SHARE_CONTENT_CHAT = game.share_content_chat;
				SHARE_TITLE_PYQ = game.share_title_pyq;
				SHARE_CONTENT_PYQ = game.share_content_pyq;
				SHARE_TITLE_QQ = game.share_title_qq;
				SHARE_CONTENT_QQ = game.share_content_qq;
				EVALUATE_A = game.evaluate;
				EVALUATE_I = game.evaluate;
			}
		},
		// error handler (optional)
		function(data, xhr) {
			// alert("AHHHHHHHHHHHH, PROBLEM LOADING WORDS");
			console.error(data, xhr.status)
		}
	);
}

// talkingdata
var tdAccount = function(){
	if(typeof(TDGA)!="undefined")
	{
		TDGA.Account({
			accountId : TDGA.getDeviceId(),
			level : 1,
			gameServer : '服务器',
			accountType : 1,
			age : 24,
			accountName : '昵称',
			gender : 1
		});
	}
	else
	{
		setTimeout("tdAccount()", 3000);
	}
}


window.onload = function(){
	// 适配
	var rate = screen.height / 1920 * 1.5;
	document.body.style.zoom = rate;
	tdAccount();

	// PRELOADER
	Q.all([
		Loader.loadAssets(Loader.manifestPreload),
		Words.convert("words.html")
	]).then(function(){
		// close splash
		if(typeof plus !== "undefined")
		{
			plus.navigator.closeSplashscreen();
		}

		// CHANGE DOM
		document.body.removeChild($("#preloader"));
		$("#main").style.display = "block";
		//$("#footer").style.display = "block"; // 打开则显示页脚（在页面按↓）
		$("#headerzj").style.display = "block";
		if(browserzj.versions.iPhone || browserzj.versions.iPad || browserzj.versions.ios || browserzj.versions.android)
		{
			$("#evaluatezj").style.display = "block";
		}

		// Slideshow
		slideshow = new Slideshow({
			dom: $("#slideshow"),
			slides: SLIDES
		});

		// Slide Select
		slideSelect = new SlideSelect({
			dom: $("#select"),
			slides: SLIDES
		});
		slideSelect.dom.style.display = "none";
		subscribe("start/game", function(){
			slideSelect.dom.style.display = "block";
			$("#translations").style.display = "none";

			// [FOR DEBUGGING]
			publish("slideshow/next");
			//publish("slideshow/scratch", ["credits"]);

		});
		subscribe("start/game_no_publish", function(){
			slideSelect.dom.style.display = "block";
			$("#translations").style.display = "none";

		});

		// SOUND
		var _soundIsOn = true;
		$("#sound_icon").onclick = function(){
			_soundIsOn = !_soundIsOn;
			Howler.mute(!_soundIsOn);
			$("#sound").setAttribute("sound", _soundIsOn?"on":"off");
		};

		// LOAD REAL THINGS
		Loader.loadAssets(
			Loader.manifest,
			function(){
				$("#sharezj").onclick = function(){
					shareHref();
				};
				$("#evaluatezj").onclick = function(){
					showEvaluate();
				};
				requestBanner();
				publish("preloader/done");
			},
			function(ratio){
				publish("preloader/progress", [ratio]);
			}
		);

		// First slide!
		slideshow.nextSlide();
		

	});

};


// 分享相关
// 分享链接
function shareHref(){
	var shareBts=[];
	// 更新分享列表
	var ss=shares['weixin'];
	ss&&ss.nativeClient&&(shareBts.push({title:'微信朋友圈',s:ss,x:'WXSceneTimeline',shareType:'pyq'}),
	shareBts.push({title:'微信好友',s:ss,x:'WXSceneSession',shareType:'chat'}));
	ss=shares['qq'];
	ss&&ss.nativeClient&&shareBts.push({title:'QQ',s:ss,shareType:'qq'});
	// 弹出分享列表
	shareBts.length>0?plus.nativeUI.actionSheet({title:'分享链接',cancel:'取消',buttons:shareBts},function(e){
		(e.index>0)&&shareAction(shareBts[e.index-1],true);
	}):plus.nativeUI.alert('当前环境无法支持分享链接操作!');
}

/**
   * 分享操作
   * @param {JSON} sb 分享操作对象s.s为分享通道对象(plus.share.ShareService)
   * @param {Boolean} bh 是否分享链接
   */
function shareAction(sb,bh) {
	if(!sb||!sb.s){
		return;
	}
	var title = "";
	var content = "";
	var link = SHARE_LINK;
	if(sb.shareType == "chat")
	{
		title = SHARE_TITLE_CHAT;
		content = SHARE_CONTENT_CHAT;
	}
	else if(sb.shareType == "pyq")
	{
		title = SHARE_TITLE_PYQ;
		content = SHARE_CONTENT_PYQ;
	}
	else if(sb.shareType == "qq")
	{
		title = SHARE_TITLE_QQ;
		content = SHARE_CONTENT_QQ;
	}
	var msg={content:content,extra:{scene:sb.x}};
	if(bh){
		msg.href=link;
		// if(sharehrefTitle&&sharehrefTitle.value!=''){
			msg.title=title;
		// }
		// if(sharehrefDes&&sharehrefDes.value!=''){
			msg.content=content;
		// }
		msg.thumbs=['_www/logo.png'];
		msg.pictures=['_www/logo.png'];
	}else{
		if(pic&&pic.realUrl){
			msg.pictures=[pic.realUrl];
		}
	}
	// 发送分享
	if(sb.s.authenticated){
		shareMessage(msg, sb.s);
	}else{
		sb.s.authorize(function(){
			shareMessage(msg,sb.s);
		}, function(e){
			console.error("授权失败");
		});
	}
}
/**
   * 发送分享消息
   * @param {JSON} msg
   * @param {plus.share.ShareService} s
   */
function shareMessage(msg, s){
	s.send(msg, function(){
		// outLine('分享到"'+s.description+'"成功！');
	}, function(e){
		// outLine('分享到"'+s.description+'"失败: '+JSON.stringify(e));
	});
}